/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20180427 (64-bit version)(RM)
 * Copyright (c) 2000 - 2018 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-8.aml, Tue Dec  6 00:08:17 2022
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000036D (877)
 *     Revision         0x01
 *     Checksum         0x49
 *     OEM ID           "HUAWEI"
 *     OEM Table ID     "CFL-ULT"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("", "SSDT", 1, "HUAWEI", "CFL-ULT", 0x00001000)
{
    /*
     * External declarations were imported from
     * a reference file -- DSDT.aml
     */

    External (_SB_.GNUM, MethodObj)    // 1 Arguments (from opcode)
    External (_SB_.PCI0.LPCB.HWEC.ECMD, MethodObj)    // 1 Arguments (from opcode)
    External (_SB_.SHPO, MethodObj)    // 2 Arguments (from opcode)
    External (ADBG, MethodObj)    // 1 Arguments (from opcode)

    OperationRegion (HWNS, SystemMemory, 0x6FB84C98, 0x00000029)
    Field (HWNS, AnyAcc, NoLock, Preserve)
    {
        PFID,   8, 
        HN01,   8, 
        HN02,   8, 
        HN03,   8, 
        HN04,   8, 
        HN05,   8, 
        HN06,   8, 
        HN07,   8, 
        FPDA,   64, 
        FPKY,   64, 
        AIAD,   64, 
        BNKY,   64, 
        FPSW,   8
    }

    Scope (\_SB)
    {
        Device (SPBA)
        {
            Name (_HID, "GXFP51B7")  // _HID: Hardware ID
            Name (_CID, "GXFP51B7")  // _CID: Compatible ID
            Name (_UID, One)  // _UID: Unique ID
            Method (_INI, 0, NotSerialized)  // _INI: Initialize
            {
                SHPO (0x04070010, One)
                SHPO (0x0403000E, One)
            }

            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If (FPSW)
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (Zero)
                }
            }

            Method (_CRS, 0, Serialized)  // _CRS: Current Resource Settings
            {
                Name (RBUF, ResourceTemplate ()
                {
                    Memory32Fixed (ReadWrite,
                        0x00000000,         // Address Base
                        0x00008000,         // Address Length
                        _Y00)
                    GpioInt (Level, ActiveLow, ExclusiveAndWake, PullDefault, 0x0000,
                        "\\_SB.PCI0.GPI0", 0x00, ResourceConsumer, ,
                        )
                        {   // Pin list
                            0x0000
                        }
                    GpioIo (Exclusive, PullUp, 0x0000, 0x0000, IoRestrictionOutputOnly,
                        "\\_SB.PCI0.GPI0", 0x00, ResourceConsumer, ,
                        )
                        {   // Pin list
                            0x0000
                        }
                })
                CreateDWordField (RBUF, \_SB.SPBA._CRS._Y00._BAS, CBAS)  // _BAS: Base Address
                CreateWordField (RBUF, 0x23, GPIN)
                CreateWordField (RBUF, 0x4B, SPIN)
                Store (GNUM (0x04070010), GPIN)
                Store (GNUM (0x0403000E), SPIN)
                Store (FPDA, CBAS)
                Return (RBUF)
            }

            OperationRegion (HWFP, SystemMemory, FPKY, 0x0800)
            Field (HWFP, AnyAcc, NoLock, Preserve)
            {
                FPDT,   16384
            }

            Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
            {
                If (LEqual (Arg0, ToUUID ("cc58b68a-4479-4893-a8bb-961209db59e5")))
                {
                    If (LEqual (Zero, ToInteger (Arg1)))
                    {
                        Switch (ToInteger (Arg2))
                        {
                            Case (Zero)
                            {
                                Return (Buffer (One)
                                {
                                     0x1F                                           
                                })
                            }
                            Case (One)
                            {
                                Name (BUFF, Buffer (0x0800){})
                                Store (FPDT, BUFF)
                                Return (BUFF)
                            }
                            Case (0x02)
                            {
                                If (CondRefOf (\_SB.PCI0.LPCB.HWEC.ECMD))
                                {
                                    Store (\_SB.PCI0.LPCB.HWEC.ECMD (0xF0), Local0)
                                    ADBG (Concatenate ("ECMD:", ToHexString (Local0)))
                                }
                            }
                            Case (0x03)
                            {
                                If (CondRefOf (\_SB.PCI0.LPCB.H_EC.ECMD))
                                {
                                    Store (\_SB.PCI0.LPCB.HWEC.ECMD (0xF1), Local0)
                                    ADBG (Concatenate ("ECMD:", ToHexString (Local0)))
                                }
                            }
                            Case (0x04)
                            {
                                If (CondRefOf (\_SB.PCI0.LPCB.H_EC.ECMD))
                                {
                                    Store (\_SB.PCI0.LPCB.HWEC.ECMD (0xF2), Local0)
                                    ADBG (Concatenate ("ECMD:", ToHexString (Local0)))
                                }
                            }

                        }
                    }
                }

                Return (Buffer (One)
                {
                     0x00                                           
                })
            }
        }
    }
}

