/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20180427 (64-bit version)(RM)
 * Copyright (c) 2000 - 2018 Intel Corporation
 * 
 * Disassembling to non-symbolic legacy ASL operators
 *
 * Disassembly of SSDT-3.aml, Tue Dec  6 00:08:18 2022
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00002A85 (10885)
 *     Revision         0x01
 *     Checksum         0x99
 *     OEM ID           "HUAWEI"
 *     OEM Table ID     "CFL-ULT"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("", "SSDT", 1, "HUAWEI", "CFL-ULT", 0x00001000)
{
    /*
     * External declarations were imported from
     * a reference file -- DSDT.aml
     */

    External (_SB_.CPPC, IntObj)    // (from opcode)
    External (_SB_.IETM, DeviceObj)    // (from opcode)
    External (_SB_.PCI0.LPCB.HWEC.ECCD, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.LPCB.HWEC.GBRF, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.LPCB.HWEC.GBTN, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.LPCB.HWEC.SBTF, MethodObj)    // 4 Arguments (from opcode)
    External (_SB_.PCI0.LPCB.HWEC.SBTN, MethodObj)    // 3 Arguments (from opcode)
    External (_SB_.PCI0.LPCB.HWEC.WMEN, UnknownObj)    // (from opcode)
    External (ODV0, IntObj)    // (from opcode)
    External (ODV1, IntObj)    // (from opcode)
    External (ODV2, IntObj)    // (from opcode)
    External (ODV3, IntObj)    // (from opcode)
    External (ODV4, IntObj)    // (from opcode)
    External (ODV5, IntObj)    // (from opcode)
    External (SSMP, UnknownObj)    // (from opcode)

    Name (PAFL, 0x02)
    Method (GVER, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        CreateWordField (BUFF, One, BMJV)
        CreateWordField (BUFF, 0x03, BMNV)
        Store (Zero, STAT)
        Store (0x0100, BMJV)
        Store (0x0F00, BMNV)
        Return (BUFF)
    }

    Method (GTSI, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        CreateQWordField (BUFF, One, TSIN)
        Store (Zero, STAT)
        Store (0x00E081C3, TSIN)
        Return (BUFF)
    }

    Method (GTMP, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Name (REMA, Zero)
        CreateByteField (Arg0, 0x02, TEPE)
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (BUFF, One, TEM0)
        CreateByteField (BUFF, 0x02, TEM1)
        CreateByteField (BUFF, 0x03, TEM2)
        Store (Zero, STAT)
        If (LEqual (TEPE, Zero))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x61, One, One), Local1)
        }
        ElseIf (LEqual (TEPE, One))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x61, One, 0x02), Local1)
        }
        ElseIf (LEqual (TEPE, 0x05))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x61, One, 0x03), Local1)
        }
        ElseIf (LEqual (TEPE, 0x06))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x61, One, 0x04), Local1)
        }
        ElseIf (LEqual (TEPE, 0x07))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x61, One, 0x05), Local1)
        }
        ElseIf (LEqual (TEPE, 0x08))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x61, One, 0x06), Local1)
        }
        ElseIf (LEqual (TEPE, 0x0E))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x61, One, 0x07), Local1)
        }
        ElseIf (LEqual (TEPE, 0x0F))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x61, One, 0x0A), Local1)
        }
        ElseIf (LEqual (TEPE, 0x15))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x61, One, 0x08), Local1)
        }
        ElseIf (LEqual (TEPE, 0x16))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x61, One, 0x09), Local1)
        }
        ElseIf (LEqual (TEPE, 0x19))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x61, One, 0x0B), Local1)
        }
        ElseIf (LEqual (TEPE, 0x1A))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x61, One, 0x0C), Local1)
        }
        ElseIf (LEqual (TEPE, 0x1F))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBRF (0x79, One, One), Local1)
            Divide (Local1, 0x0A, REMA, Local1)
        }
        ElseIf (LEqual (TEPE, 0x20))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBRF (0x79, One, 0x02), Local1)
            Divide (Local1, 0x0A, REMA, Local1)
        }
        ElseIf (LEqual (TEPE, 0x23))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBRF (0x79, One, 0x03), Local1)
            Divide (Local1, 0x0A, REMA, Local1)
        }
        ElseIf (LEqual (TEPE, 0x24))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBRF (0x79, One, 0x04), Local1)
            Divide (Local1, 0x0A, REMA, Local1)
        }
        ElseIf (LEqual (TEPE, 0x25))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBRF (0x79, One, 0x06), Local1)
            Divide (Local1, 0x0A, REMA, Local1)
        }
        ElseIf (LEqual (TEPE, 0x26))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBRF (0x79, One, 0x07), Local1)
            Divide (Local1, 0x0A, REMA, Local1)
        }
        ElseIf (LEqual (TEPE, 0x27))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBRF (0x79, One, 0x05), Local1)
            Divide (Local1, 0x0A, REMA, Local1)
        }
        ElseIf (LEqual (TEPE, 0x28))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBRF (0x79, One, 0x09), Local1)
            Divide (Local1, 0x0A, REMA, Local1)
        }
        ElseIf (LEqual (TEPE, 0x29))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBRF (0x79, One, 0x0A), Local1)
            Divide (Local1, 0x0A, REMA, Local1)
        }
        ElseIf (LEqual (TEPE, 0x2A))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBRF (0x79, One, 0x08), Local1)
            Divide (Local1, 0x0A, REMA, Local1)
        }
        Else
        {
            Store (Zero, Local1)
            Store (One, STAT)
        }

        Store (Local1, TEM1)
        Store (Zero, TEM0)
        Store (REMA, TEM2)
        Return (BUFF)
    }

    Method (STMT, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (Arg0, 0x02, SSRN)
        CreateByteField (Arg0, 0x05, TUPL)
        CreateByteField (Arg0, 0x07, TDNL)
        Store (Zero, Local1)
        If (LGreater (TDNL, TUPL))
        {
            Store (0xFF, Local1)
        }

        If (LEqual (Local1, Zero))
        {
            If (LEqual (SSRN, Zero))
            {
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, One, TUPL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x02, TDNL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, One, One)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x02, One)
            }
            ElseIf (LEqual (SSRN, One))
            {
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x03, TUPL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x04, TDNL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x03, One)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x04, One)
            }
            ElseIf (LEqual (SSRN, 0x05))
            {
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x05, TUPL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x06, TDNL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x05, One)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x06, One)
            }
            ElseIf (LEqual (SSRN, 0x06))
            {
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x07, TUPL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x08, TDNL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x07, One)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x08, One)
            }
            ElseIf (LEqual (SSRN, 0x07))
            {
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x09, TUPL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x0A, TDNL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x09, One)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x0A, One)
            }
            ElseIf (LEqual (SSRN, 0x08))
            {
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x0B, TUPL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x0C, TDNL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x0B, One)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x0C, One)
            }
            ElseIf (LEqual (SSRN, 0x0E))
            {
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x0D, TUPL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x0E, TDNL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x0D, One)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x0E, One)
            }
            ElseIf (LEqual (SSRN, 0x0B))
            {
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x1B, TUPL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x1C, TDNL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x1B, One)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x0C, One)
            }
            ElseIf (LEqual (SSRN, 0x15))
            {
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x0F, TUPL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x10, TDNL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x0F, One)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x10, One)
            }
            ElseIf (LEqual (SSRN, 0x16))
            {
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x11, TUPL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x12, TDNL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x11, One)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x12, One)
            }
            ElseIf (LEqual (SSRN, 0x0F))
            {
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x15, TUPL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x16, TDNL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x15, One)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x16, One)
            }
            ElseIf (LEqual (SSRN, 0x19))
            {
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x17, TUPL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x18, TDNL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x17, One)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x18, One)
            }
            ElseIf (LEqual (SSRN, 0x1A))
            {
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x19, TUPL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x62, 0x02, 0x1A, TDNL)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x19, One)
                \_SB.PCI0.LPCB.HWEC.SBTF (0x70, 0x02, 0x1A, One)
            }

            Store (Zero, STAT)
        }
        Else
        {
            Store (One, STAT)
        }

        Return (BUFF)
    }

    Method (GPSI, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (BUFF, One, PSIT)
        Store (0x05, PSIT)
        Store (Zero, STAT)
        Return (BUFF)
    }

    Method (GPCI, 1, Serialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Name (IADP, Zero)
        Name (IBAT, Zero)
        Name (VBAT, Zero)
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (BUFF, One, POVA)
        CreateByteField (Local0, 0x02, GTST)
        Switch (ToInteger (GTST))
        {
            Case (Zero)
            {
                Store (Zero, Local1)
                Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x63, One, One), IADP)
                ShiftLeft (IADP, 0x08, IADP)
                Or (\_SB.PCI0.LPCB.HWEC.GBTN (0x63, One, 0x02), IADP, IADP)
                Multiply (IADP, 0x023A, Local1)
                Divide (Local1, 0x07D0, , Local1)
                Store (Local1, POVA)
            }
            Case (0x02)
            {
                Store (Zero, Local1)
                Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x63, One, 0x03), IBAT)
                ShiftLeft (IBAT, 0x08, IBAT)
                Or (\_SB.PCI0.LPCB.HWEC.GBTN (0x63, One, 0x04), IBAT, IBAT)
                Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x63, One, 0x05), VBAT)
                ShiftLeft (VBAT, 0x08, VBAT)
                Or (\_SB.PCI0.LPCB.HWEC.GBTN (0x63, One, 0x06), VBAT, VBAT)
                Multiply (IBAT, 0x0F, IBAT)
                Multiply (IBAT, VBAT, Local1)
                Divide (Local1, 0x000F4240, , Local1)
                Store (Local1, POVA)
            }
            Default
            {
                Store (Zero, POVA)
                Store (One, STAT)
            }

        }

        Store (Zero, STAT)
        If (LEqual (POVA, Zero))
        {
            Store (One, STAT)
        }

        Return (BUFF)
    }

    Method (GLIV, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (BUFF, One, AMLL)
        CreateByteField (BUFF, 0x02, KBLL)
        Store (0xFF, AMLL)
        Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x64, Zero, Zero), KBLL)
        Store (Zero, STAT)
        Return (BUFF)
    }

    Method (SLIV, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (Arg0, 0x02, SOCP)
        CreateByteField (BUFF, Zero, STAT)
        \_SB.PCI0.LPCB.HWEC.SBTN (0x65, One, SOCP)
        Store (Zero, STAT)
        Return (BUFF)
    }

    Method (GFNS, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (Local0, 0x02, FNSN)
        CreateByteField (BUFF, Zero, STAT)
        CreateWordField (BUFF, One, FNSS)
        Store (Zero, STAT)
        If (LEqual (FNSN, Zero))
        {
            ShiftLeft (\_SB.PCI0.LPCB.HWEC.GBTN (0x66, One, One), 0x08, Local1)
            Or (\_SB.PCI0.LPCB.HWEC.GBTN (0x66, One, 0x02), Local1, Local2)
            Store (Local2, FNSS)
        }
        ElseIf (LEqual (FNSN, One))
        {
            Store (One, STAT)
        }

        Return (BUFF)
    }

    Method (GCVA, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (Local0, 0x02, VANU)
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (BUFF, One, FLAG)
        CreateByteField (BUFF, 0x02, VALH)
        CreateByteField (BUFF, 0x03, VALL)
        If (LEqual (VANU, Zero))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x67, One, One), VALH)
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x67, One, 0x02), VALL)
        }
        ElseIf (LEqual (VANU, One))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x67, One, 0x05), VALH)
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x67, One, 0x06), VALL)
        }

        If (LEqual (VANU, 0x10))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x67, One, 0x03), VALH)
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x67, One, 0x04), VALL)
        }
        ElseIf (LEqual (VANU, 0x11))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x67, One, 0x07), VALH)
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x67, One, 0x08), VALL)
        }

        If (LEqual (VANU, 0x20))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x67, One, 0x09), VALH)
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x67, One, 0x0A), VALL)
        }
        ElseIf (LEqual (VANU, 0x30))
        {
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x67, One, 0x0B), VALH)
            Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x67, One, 0x0C), VALL)
        }

        Store (Zero, STAT)
        Return (BUFF)
    }

    Method (GCPL, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (SPLV, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (GODP, 1, Serialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (BUFF, One, DOUT)
        CreateByteField (Local0, 0x02, INVX)
        Store (Zero, STAT)
        Switch (ToInteger (INVX))
        {
            Case (Zero)
            {
                Store (\ODV0, DOUT)
                Break
            }
            Case (One)
            {
                Store (\ODV1, DOUT)
                Break
            }
            Case (0x02)
            {
                Store (\ODV2, DOUT)
                Break
            }
            Case (0x03)
            {
                Store (\ODV3, DOUT)
                Break
            }
            Case (0x04)
            {
                Store (\ODV4, DOUT)
                Break
            }
            Case (0x05)
            {
                Store (\ODV5, DOUT)
                Break
            }

        }

        Return (BUFF)
    }

    Method (SODP, 1, Serialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        CreateByteField (Arg0, 0x02, ODVN)
        CreateByteField (Arg0, 0x03, ACIR)
        If (LLessEqual (ACIR, 0x3F))
        {
            If (LLessEqual (ODVN, 0x05))
            {
                Switch (ToInteger (ODVN))
                {
                    Case (0x05)
                    {
                        Store (ACIR, \ODV5)
                        Break
                    }
                    Case (0x04)
                    {
                        Store (ACIR, \ODV4)
                        Break
                    }
                    Case (0x03)
                    {
                        Store (ACIR, \ODV3)
                        Break
                    }
                    Case (0x02)
                    {
                        Store (ACIR, \ODV2)
                        Break
                    }
                    Case (One)
                    {
                        Store (ACIR, \ODV1)
                        Break
                    }
                    Case (Zero)
                    {
                        Store (ACIR, \ODV0)
                        \_SB.PCI0.LPCB.HWEC.SBTF (0x68, 0x02, 0x04, ACIR)
                        Break
                    }

                }

                Notify (\_SB.IETM, 0x88)
            }
        }

        Return (BUFF)
    }

    Method (SBTT, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (Arg0, 0x02, STCP)
        CreateByteField (Arg0, 0x03, SOCP)
        CreateByteField (BUFF, Zero, STAT)
        If (LAnd (LEqual (STCP, Zero), LEqual (SOCP, 0x64)))
        {
            \_SB.PCI0.LPCB.HWEC.SBTF (0x68, 0x02, 0x03, 0x55)
        }
        Else
        {
            \_SB.PCI0.LPCB.HWEC.SBTF (0x68, 0x02, One, STCP)
            \_SB.PCI0.LPCB.HWEC.SBTF (0x68, 0x02, 0x02, SOCP)
            \_SB.PCI0.LPCB.HWEC.SBTF (0x68, 0x02, 0x03, 0x5A)
        }

        Store (Zero, STAT)
        Return (BUFF)
    }

    Method (GBTT, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (BUFF, One, STCP)
        CreateByteField (BUFF, 0x02, SOCP)
        Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x69, One, One), STCP)
        Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x69, One, 0x02), SOCP)
        Store (Zero, STAT)
        Return (BUFF)
    }

    Method (BACF, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Arg0, Local0)
        CreateByteField (Local0, 0x02, FLAG)
        If (LEqual (FLAG, One))
        {
            \_SB.PCI0.LPCB.HWEC.SBTN (0xE5, Zero, Zero)
        }

        Return (BUFF)
    }

    Method (ACOL, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        CreateWordField (BUFF, One, LBAC)
        Store (\_SB.PCI0.LPCB.HWEC.GBRF (0xE2, Zero, Zero), LBAC)
        Return (BUFF)
    }

    Method (BACG, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        CreateByteField (BUFF, One, STCP)
        Store (\_SB.PCI0.LPCB.HWEC.GBTN (0xE4, One, One), STCP)
        Return (BUFF)
    }

    Method (CGMD, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Name (GBT1, Buffer (0x08){})
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Arg0, Local0)
        CreateByteField (Local0, 0x02, MODE)
        CreateByteField (Local0, 0x03, TIME)
        CreateByteField (Local0, 0x04, SART)
        CreateByteField (Local0, 0x05, STOP)
        Store (MODE, Index (GBT1, Zero))
        Store (TIME, Index (GBT1, One))
        Store (SART, Index (GBT1, 0x02))
        Store (STOP, Index (GBT1, 0x03))
        \_SB.PCI0.LPCB.HWEC.ECCD (0xE3, 0x04, GBT1)
        Return (BUFF)
    }

    Method (CGMG, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Name (GBT2, Buffer (0x22){})
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (\_SB.PCI0.LPCB.HWEC.ECCD (0xE6, Zero, Zero), GBT2)
        CreateByteField (GBT2, 0x02, TEP1)
        CreateByteField (GBT2, 0x03, TEP2)
        CreateByteField (GBT2, 0x04, TEP3)
        CreateByteField (GBT2, 0x05, TEP4)
        CreateByteField (BUFF, One, MODE)
        CreateByteField (BUFF, 0x02, TIME)
        CreateByteField (BUFF, 0x03, SART)
        CreateByteField (BUFF, 0x04, STOP)
        Store (TEP1, MODE)
        Store (TEP2, TIME)
        Store (TEP3, SART)
        Store (TEP4, STOP)
        Return (BUFF)
    }

    Method (PAFS, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (BUFF, One, PAFS)
        Store (PAFL, PAFS (Store (Zero, STAT)))
        Return (BUFF)
    }

    Method (PAFF, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (Local0, 0x02, PAFR)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        If (LEqual (PAFR, One))
        {
            \_SB.PCI0.LPCB.HWEC.SBTN (0x6A, One, 0x5A)
            Store (One, PAFL)
            Store (Zero, STAT)
        }
        ElseIf (LEqual (PAFR, 0x02))
        {
            \_SB.PCI0.LPCB.HWEC.SBTN (0x6A, One, 0x55)
            Store (0x02, PAFL)
            Store (Zero, STAT)
        }
        Else
        {
            Store (One, STAT)
        }

        Return (BUFF)
    }

    Method (GFRS, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (BUFF, One, RELT)
        Store (Zero, STAT)
        Store (0x02, RELT)
        Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x6B, Zero, Zero), Local1)
        And (Local1, 0xFF, Local1)
        If (LEqual (Local1, 0x55))
        {
            Store (One, RELT)
        }

        Return (BUFF)
    }

    Method (SFRS, 1, Serialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Name (RELT, Zero)
        Name (TEMP, Zero)
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (Arg0, 0x02, SFNM)
        Switch (ToInteger (SFNM))
        {
            Case (One)
            {
                \_SB.PCI0.LPCB.HWEC.SBTN (0x6C, One, 0x55)
                \_SB.PCI0.LPCB.HWEC.SBTN (0x6C, One, 0x51)
                Break
            }
            Case (0x02)
            {
                \_SB.PCI0.LPCB.HWEC.SBTN (0x6C, One, 0x5A)
                \_SB.PCI0.LPCB.HWEC.SBTN (0x6C, One, 0x50)
                Break
            }
            Default
            {
                Store (One, STAT)
            }

        }

        Store (Zero, STAT)
        Return (BUFF)
    }

    Method (SPDT, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (Arg0, 0x02, DTIM)
        CreateByteField (BUFF, Zero, STAT)
        Store (One, STAT)
        If (LAnd (LLessEqual (DTIM, 0x28), LGreaterEqual (DTIM, Zero)))
        {
            Store (DTIM, Local0)
            Multiply (Local0, 0x14, Local1)
            And (Local1, 0xFF, Local0)
            ShiftRight (Local1, 0x08, Local1)
            \_SB.PCI0.LPCB.HWEC.SBTF (0x6D, 0x02, Local0, Local1)
            Store (Zero, STAT)
        }

        Return (BUFF)
    }

    Method (RPDT, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (BUFF, One, PBDT)
        Store (One, STAT)
        Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x6E, One, One), Local0)
        Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x6E, One, 0x02), Local1)
        ShiftLeft (Local1, 0x08, Local1)
        Or (Local0, Local1, Local0)
        Divide (Local0, 0x14, , Local0)
        If (LAnd (LLessEqual (Local0, 0x28), LGreaterEqual (Local0, Zero)))
        {
            Store (Local0, PBDT)
            Store (Zero, STAT)
        }

        Return (BUFF)
    }

    Method (RPPT, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (BUFF, One, PBPT)
        Store (One, STAT)
        Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x6F, One, One), Local0)
        Store (\_SB.PCI0.LPCB.HWEC.GBTN (0x6F, One, 0x02), Local1)
        ShiftLeft (Local1, 0x08, Local1)
        Or (Local0, Local1, Local0)
        Divide (Local0, 0x14, , Local0)
        Store (Local0, PBPT)
        Store (Zero, STAT)
        Return (BUFF)
    }

    Method (SMLS, 1, Serialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        Store (Arg0, Local0)
        CreateByteField (Local0, 0x02, MCLD)
        Store (One, Local1)
        Switch (ToInteger (MCLD))
        {
            Case (Zero)
            {
                \_SB.PCI0.LPCB.HWEC.SBTN (0x77, One, 0x55)
            }
            Case (One)
            {
                \_SB.PCI0.LPCB.HWEC.SBTN (0x77, One, 0x5A)
            }
            Default
            {
                Store (Zero, Local1)
            }

        }

        If (LEqual (Local1, One))
        {
            Store (Zero, STAT)
        }
        Else
        {
            Store (One, STAT)
        }

        Return (BUFF)
    }

    Method (GWKM, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (BUFF, Zero, STAT)
        CreateByteField (BUFF, One, CWMO)
        Store (Zero, STAT)
        Store (\ODV3, CWMO)
        Return (BUFF)
    }

    Method (SWKM, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        CreateByteField (Arg0, 0x02, SCMO)
        CreateByteField (BUFF, Zero, STAT)
        If (LEqual (SCMO, Zero))
        {
            Store (Zero, \ODV3)
            Store (Zero, \ODV0)
            Notify (\_SB.IETM, 0x88)
            \_SB.PCI0.LPCB.HWEC.SBTF (0x68, 0x02, 0x05, Zero)
        }

        If (LEqual (SCMO, One))
        {
            Store (One, \ODV3)
            Store (0x04, \ODV0)
            Notify (\_SB.IETM, 0x88)
            \_SB.PCI0.LPCB.HWEC.SBTF (0x68, 0x02, 0x05, 0x04)
        }

        If (LEqual (SCMO, 0x02))
        {
            Store (0x02, \ODV3)
            Store (0x04, \ODV0)
            Notify (\_SB.IETM, 0x88)
            \_SB.PCI0.LPCB.HWEC.SBTF (0x68, 0x02, 0x05, 0x05)
        }

        Store (Zero, STAT)
        Return (BUFF)
    }

    Method (GSUS, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (SSUS, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (SNTB, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (GNTB, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (SOSF, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (GOSF, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (SKBT, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (GKBT, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (SPDV, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (GPDV, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (GLOG, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (GSWL, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    Method (GECL, 1, NotSerialized)
    {
        Name (BUFF, Buffer (0x0100){})
        Store (Arg0, Local0)
        CreateByteField (BUFF, Zero, STAT)
        Store (Zero, STAT)
        Store (Local0, DAIN)
        HSMI ()
        Store (DAOU, BUFF)
        Return (BUFF)
    }

    OperationRegion (ONVS, SystemMemory, 0x6FB87000, 0x00000140)
    Field (ONVS, AnyAcc, NoLock, Preserve)
    {
        DAIN,   512, 
        DAOU,   2048
    }

    Method (HSMI, 0, NotSerialized)
    {
        Store (0xC1, SSMP)
    }

    Scope (\_SB)
    {
        Mutex (MUTW, 0x00)
        Device (AMW0)
        {
            Name (_HID, EisaId ("PNP0C14"))  // _HID: Hardware ID
            Name (_UID, "HWMI")  // _UID: Unique ID
            Name (_WDG, Buffer (0x3C)
            {
                /* 0000 */  0x5B, 0x0F, 0xBC, 0xAB, 0xA1, 0x8E, 0xD1, 0x11,
                /* 0008 */  0xA0, 0x00, 0xC9, 0x06, 0x29, 0x10, 0x00, 0x00,
                /* 0010 */  0x41, 0x41, 0x01, 0x02, 0x5C, 0x0F, 0xBC, 0xAB,
                /* 0018 */  0xA1, 0x8E, 0xD1, 0x11, 0xA0, 0x00, 0xC9, 0x06,
                /* 0020 */  0x29, 0x10, 0x00, 0x00, 0xA0, 0x00, 0x01, 0x08,
                /* 0028 */  0x21, 0x12, 0x90, 0x05, 0x66, 0xD5, 0xD1, 0x11,
                /* 0030 */  0xB2, 0xF0, 0x00, 0xA0, 0xC9, 0x06, 0x29, 0x10,
                /* 0038 */  0x42, 0x41, 0x01, 0x00                         
            })
            Name (WQBA, Buffer (0x03EE)
            {
                /* 0000 */  0x46, 0x4F, 0x4D, 0x42, 0x01, 0x00, 0x00, 0x00,
                /* 0008 */  0xDE, 0x03, 0x00, 0x00, 0x38, 0x0C, 0x00, 0x00,
                /* 0010 */  0x44, 0x53, 0x00, 0x01, 0x1A, 0x7D, 0xDA, 0x54,
                /* 0018 */  0x18, 0xD3, 0x85, 0x00, 0x01, 0x06, 0x18, 0x42,
                /* 0020 */  0x10, 0x05, 0x10, 0x92, 0xE5, 0x81, 0x42, 0x04,
                /* 0028 */  0x8A, 0x40, 0x24, 0x69, 0x0E, 0x60, 0x30, 0x1A,
                /* 0030 */  0x40, 0x24, 0x09, 0x42, 0xBC, 0x22, 0x20, 0x42,
                /* 0038 */  0x20, 0x24, 0x51, 0x80, 0x79, 0x01, 0xBA, 0x05,
                /* 0040 */  0x18, 0x16, 0x60, 0x5B, 0x80, 0x69, 0x01, 0x8E,
                /* 0048 */  0x81, 0xD4, 0xBF, 0x3F, 0xB4, 0x40, 0x24, 0x02,
                /* 0050 */  0x92, 0x4A, 0x81, 0x90, 0x50, 0x01, 0xCA, 0x05,
                /* 0058 */  0xF8, 0x16, 0xA0, 0x1D, 0x51, 0x92, 0x05, 0x58,
                /* 0060 */  0x86, 0x11, 0x81, 0xBD, 0x0A, 0xB0, 0x29, 0xC0,
                /* 0068 */  0x24, 0x1A, 0x82, 0xA0, 0x9C, 0x61, 0xA0, 0xE0,
                /* 0070 */  0x0D, 0xC8, 0x06, 0xC1, 0x44, 0x0F, 0x02, 0x25,
                /* 0078 */  0x66, 0x34, 0x64, 0x06, 0x9D, 0xCF, 0x45, 0xF0,
                /* 0080 */  0x27, 0x51, 0xB8, 0x00, 0xE9, 0x18, 0x1A, 0xC1,
                /* 0088 */  0x11, 0x25, 0xE8, 0x70, 0x48, 0x92, 0x8D, 0x20,
                /* 0090 */  0x41, 0x02, 0x14, 0xC2, 0xCB, 0xA7, 0x00, 0xA7,
                /* 0098 */  0x28, 0xD2, 0x28, 0xC0, 0x3A, 0x9C, 0x60, 0x63,
                /* 00A0 */  0x72, 0xA4, 0x28, 0x07, 0x71, 0x36, 0x06, 0xEB,
                /* 00A8 */  0x19, 0x45, 0x40, 0xA7, 0xC2, 0x09, 0xA2, 0x1F,
                /* 00B0 */  0x0A, 0x46, 0x06, 0x84, 0x3C, 0x0A, 0xB0, 0x8A,
                /* 00B8 */  0xA6, 0xB9, 0x24, 0xB0, 0x7B, 0x01, 0x06, 0x67,
                /* 00C0 */  0x21, 0x84, 0x23, 0x29, 0x4C, 0x80, 0x66, 0x01,
                /* 00C8 */  0xD6, 0x04, 0x28, 0x16, 0x60, 0x4B, 0x80, 0xB8,
                /* 00D0 */  0x21, 0x69, 0x32, 0x8D, 0xA1, 0x08, 0x22, 0xC2,
                /* 00D8 */  0x71, 0x46, 0x31, 0x66, 0xC0, 0x08, 0x46, 0x39,
                /* 00E0 */  0x9A, 0xE6, 0x40, 0xA4, 0x4D, 0x80, 0x32, 0x10,
                /* 00E8 */  0xA1, 0xC5, 0x62, 0x08, 0xB6, 0x3F, 0x08, 0x32,
                /* 00F0 */  0x72, 0xDC, 0x11, 0xC0, 0xE3, 0x39, 0xA9, 0xC8,
                /* 00F8 */  0x07, 0xE8, 0x51, 0x24, 0xF0, 0xA8, 0xCE, 0xAF,
                /* 0100 */  0x5C, 0x5C, 0x89, 0x47, 0x15, 0xC6, 0x09, 0x24,
                /* 0108 */  0x70, 0xB0, 0x13, 0x81, 0x24, 0x80, 0x28, 0x12,
                /* 0110 */  0x3C, 0x6A, 0xE0, 0x09, 0x8E, 0xDF, 0x43, 0x3B,
                /* 0118 */  0xCE, 0xA3, 0x3E, 0xCE, 0x13, 0x38, 0x57, 0x8F,
                /* 0120 */  0xA0, 0xCE, 0x53, 0x01, 0x19, 0x03, 0xC3, 0x4A,
                /* 0128 */  0xF0, 0x87, 0xE0, 0x93, 0x00, 0xDE, 0x35, 0xA0,
                /* 0130 */  0xFE, 0xFF, 0xF7, 0x83, 0x27, 0x01, 0x36, 0xE4,
                /* 0138 */  0x70, 0x98, 0xF1, 0x7A, 0xE2, 0xC7, 0xE9, 0x51,
                /* 0140 */  0x1E, 0x09, 0x83, 0x38, 0xA2, 0x83, 0xC3, 0x0E,
                /* 0148 */  0xF9, 0x64, 0x8E, 0xAC, 0x54, 0x01, 0x66, 0x4F,
                /* 0150 */  0x08, 0xB2, 0x08, 0xA4, 0xF1, 0xF8, 0x50, 0xE0,
                /* 0158 */  0xF9, 0xBC, 0x05, 0x24, 0xB0, 0xFC, 0x41, 0xA0,
                /* 0160 */  0x46, 0x66, 0x68, 0x8F, 0xFB, 0x91, 0x80, 0x1D,
                /* 0168 */  0x16, 0x0E, 0x8B, 0x89, 0x3D, 0x4C, 0xD0, 0xF1,
                /* 0170 */  0x80, 0xFF, 0x56, 0x70, 0xFC, 0x11, 0x4E, 0xDF,
                /* 0178 */  0xF3, 0x35, 0x41, 0x81, 0xC0, 0xE8, 0x01, 0xD9,
                /* 0180 */  0xAF, 0x00, 0x84, 0xE0, 0x65, 0x8E, 0x48, 0xC7,
                /* 0188 */  0x80, 0x08, 0x09, 0xDE, 0x1B, 0xE2, 0x1E, 0xF8,
                /* 0190 */  0xF3, 0x02, 0x83, 0x08, 0xF3, 0xD6, 0xE0, 0x11,
                /* 0198 */  0x1C, 0x0D, 0x13, 0x79, 0x98, 0x40, 0x0F, 0x80,
                /* 01A0 */  0x9F, 0x02, 0xE2, 0x87, 0x3D, 0x99, 0x03, 0x38,
                /* 01A8 */  0x9C, 0x28, 0xE7, 0x70, 0x3C, 0xBE, 0x42, 0x18,
                /* 01B0 */  0x21, 0xFE, 0xB3, 0xC1, 0x73, 0x86, 0xAF, 0x0D,
                /* 01B8 */  0x27, 0xF4, 0x18, 0x71, 0x4A, 0x2F, 0x03, 0x26,
                /* 01C0 */  0x18, 0xF9, 0x35, 0xA0, 0x53, 0x88, 0xE3, 0x82,
                /* 01C8 */  0xC8, 0xC6, 0x4A, 0x7D, 0xE8, 0xA0, 0x71, 0x57,
                /* 01D0 */  0xAB, 0x01, 0xE1, 0xB0, 0x9F, 0x2C, 0x4C, 0x30,
                /* 01D8 */  0x24, 0x98, 0x4E, 0x24, 0x3C, 0x1E, 0x85, 0x44,
                /* 01E0 */  0xD0, 0x68, 0x3C, 0x06, 0x77, 0xEC, 0x83, 0x09,
                /* 01E8 */  0x05, 0x31, 0xA0, 0x33, 0x41, 0xC8, 0xC8, 0x28,
                /* 01F0 */  0xE8, 0x41, 0x80, 0xCF, 0xE0, 0xA5, 0xE2, 0x91,
                /* 01F8 */  0xC1, 0xA7, 0x8E, 0x28, 0x27, 0xE4, 0x04, 0x10,
                /* 0200 */  0x3A, 0x3C, 0x78, 0x84, 0x3E, 0x08, 0xF0, 0x13,
                /* 0208 */  0x8A, 0x6F, 0x06, 0xC6, 0xF6, 0xA1, 0xC1, 0xFF,
                /* 0210 */  0xFF, 0x7F, 0x0A, 0x1D, 0x2C, 0x19, 0xD3, 0x59,
                /* 0218 */  0x3E, 0x15, 0xF8, 0x00, 0x60, 0x35, 0x70, 0x28,
                /* 0220 */  0x68, 0x1F, 0x39, 0xF8, 0xBD, 0x45, 0x77, 0x02,
                /* 0228 */  0xE8, 0xE3, 0x39, 0x10, 0x0F, 0xE8, 0x98, 0x12,
                /* 0230 */  0xD4, 0x77, 0x25, 0x00, 0x05, 0x90, 0x0F, 0x01,
                /* 0238 */  0x56, 0x7A, 0x0F, 0xA0, 0x53, 0x08, 0x11, 0x26,
                /* 0240 */  0x9A, 0xD1, 0xF9, 0x71, 0xC3, 0x43, 0xE6, 0x51,
                /* 0248 */  0x60, 0x34, 0x64, 0x83, 0x78, 0x60, 0x8E, 0x03,
                /* 0250 */  0x21, 0x27, 0x47, 0x09, 0xD4, 0x58, 0x3D, 0xA1,
                /* 0258 */  0xCE, 0x6E, 0x23, 0x1A, 0xC1, 0x9B, 0x8B, 0x0F,
                /* 0260 */  0x06, 0xEF, 0x12, 0x3E, 0x26, 0xB0, 0x61, 0x3F,
                /* 0268 */  0x72, 0xC0, 0x3A, 0xB3, 0x78, 0xF0, 0x9E, 0x88,
                /* 0270 */  0x47, 0x8D, 0x1F, 0x2E, 0x1F, 0x8D, 0x8F, 0x14,
                /* 0278 */  0xF0, 0xA7, 0xCB, 0xE7, 0xE3, 0xE1, 0x91, 0x93,
                /* 0280 */  0x01, 0xFA, 0xBC, 0xE0, 0x93, 0x81, 0xCF, 0x0B,
                /* 0288 */  0x07, 0xE3, 0x9B, 0x01, 0x27, 0x18, 0xE2, 0x68,
                /* 0290 */  0x40, 0x87, 0x05, 0xAE, 0xB3, 0x01, 0x5F, 0x96,
                /* 0298 */  0x47, 0x07, 0xEF, 0x8C, 0x44, 0x46, 0x07, 0xFD,
                /* 02A0 */  0xFF, 0x7F, 0x37, 0xC0, 0x1D, 0x3F, 0xC0, 0x71,
                /* 02A8 */  0x37, 0x80, 0x09, 0x8F, 0x39, 0x59, 0xD8, 0xC2,
                /* 02B0 */  0x78, 0xE8, 0xB0, 0xF8, 0xB1, 0xC0, 0x77, 0x8D,
                /* 02B8 */  0x37, 0x27, 0xDF, 0x45, 0x70, 0x63, 0x7A, 0x2D,
                /* 02C0 */  0xF0, 0x39, 0xC0, 0xB0, 0x1E, 0x2F, 0x87, 0x35,
                /* 02C8 */  0x5A, 0xD8, 0x13, 0x7F, 0x4A, 0xF1, 0x0D, 0xC7,
                /* 02D0 */  0x13, 0xF3, 0x0D, 0x81, 0x9D, 0x6D, 0xC0, 0x01,
                /* 02D8 */  0x88, 0xF7, 0x7E, 0xAD, 0x21, 0x13, 0x30, 0x20,
                /* 02E0 */  0x9B, 0xE3, 0x43, 0x14, 0x58, 0x8E, 0x06, 0xC7,
                /* 02E8 */  0x79, 0x6E, 0x2F, 0x4E, 0xFC, 0x0C, 0x05, 0x83,
                /* 02F0 */  0xC0, 0x31, 0x9E, 0x07, 0x06, 0xF1, 0x0A, 0x25,
                /* 02F8 */  0x1C, 0x06, 0x75, 0xF6, 0x02, 0xDE, 0x27, 0x0D,
                /* 0300 */  0x8F, 0x13, 0x1C, 0xD3, 0x7C, 0xEC, 0x30, 0xCA,
                /* 0308 */  0xFF, 0x3F, 0xD2, 0x61, 0xBE, 0x1C, 0x45, 0xF1,
                /* 0310 */  0x5C, 0x3C, 0xAE, 0x47, 0x01, 0x06, 0x75, 0xF4,
                /* 0318 */  0x2F, 0x06, 0xB1, 0x8C, 0x72, 0x6E, 0xB1, 0x0E,
                /* 0320 */  0x20, 0xCE, 0xA3, 0x83, 0x91, 0x02, 0x05, 0x39,
                /* 0328 */  0x88, 0x18, 0x81, 0x7C, 0xAE, 0xF0, 0xE9, 0x0B,
                /* 0330 */  0x5C, 0x33, 0x78, 0xFA, 0x02, 0xC6, 0x91, 0x5F,
                /* 0338 */  0x1C, 0x3A, 0x13, 0xF8, 0xF4, 0x05, 0xF0, 0xE2,
                /* 0340 */  0xFF, 0x7F, 0xFA, 0xE2, 0xD1, 0x8F, 0x40, 0xE8,
                /* 0348 */  0x51, 0xF8, 0xB0, 0x11, 0xF1, 0x30, 0x4E, 0xDB,
                /* 0350 */  0x04, 0xA3, 0x0E, 0x9A, 0x8A, 0x3A, 0xA5, 0xA0,
                /* 0358 */  0x0E, 0x17, 0x3E, 0xA5, 0xB0, 0xC3, 0xC2, 0xEB,
                /* 0360 */  0x83, 0x21, 0x1E, 0x52, 0x30, 0x07, 0x00, 0x1F,
                /* 0368 */  0x29, 0xC0, 0x31, 0x12, 0xCC, 0x69, 0xC2, 0xA7,
                /* 0370 */  0x08, 0x9F, 0x0A, 0x7D, 0x9F, 0xF0, 0xC9, 0xC3,
                /* 0378 */  0x30, 0x46, 0x32, 0x9E, 0x8F, 0x14, 0x78, 0xC8,
                /* 0380 */  0x40, 0xAF, 0x14, 0xB8, 0x83, 0x11, 0x18, 0xE5,
                /* 0388 */  0x1D, 0xDD, 0x40, 0x77, 0xFA, 0xC0, 0x9C, 0xDC,
                /* 0390 */  0x80, 0xC9, 0xD5, 0xC3, 0x43, 0xE0, 0x67, 0x09,
                /* 0398 */  0x0F, 0x81, 0x0F, 0xE0, 0x11, 0xE4, 0xEC, 0x7C,
                /* 03A0 */  0x0E, 0x3A, 0x27, 0xDC, 0x59, 0x85, 0x4F, 0x09,
                /* 03A8 */  0x37, 0x00, 0x8C, 0x42, 0x9B, 0x3E, 0x35, 0x1A,
                /* 03B0 */  0xB5, 0x6A, 0x50, 0xA6, 0x46, 0x99, 0x06, 0xB5,
                /* 03B8 */  0xFA, 0x54, 0x6A, 0xCC, 0xD8, 0xC1, 0xC1, 0xA2,
                /* 03C0 */  0xDE, 0x0E, 0x3A, 0x1C, 0x38, 0x12, 0x08, 0x15,
                /* 03C8 */  0x73, 0xB2, 0x91, 0x11, 0x10, 0x29, 0x03, 0x11,
                /* 03D0 */  0x90, 0xFF, 0xFF, 0x42, 0x9E, 0x46, 0x02, 0xB2,
                /* 03D8 */  0x2C, 0x10, 0x01, 0x39, 0x22, 0x10, 0x0D, 0x0C,
                /* 03E0 */  0x44, 0xE5, 0x9A, 0x00, 0x61, 0x61, 0x41, 0x68,
                /* 03E8 */  0x4C, 0x15, 0x20, 0xEC, 0xFF, 0x0F             
            })
            Method (WMAA, 3, Serialized)
            {
                Acquire (MUTW, 0xFFFF)
                Name (WMRP, Package (0x02)
                {
                    Buffer (0x04){}, 
                    Buffer (0x0100){}
                })
                Store (Arg2, Local0)
                CreateByteField (Local0, Zero, MFID)
                CreateByteField (Local0, One, SFID)
                Store (DerefOf (Index (WMRP, One)), Local1)
                CreateByteField (Local1, Zero, STAT)
                Store (One, STAT)
                Switch (ToInteger (MFID))
                {
                    Case (One)
                    {
                        Switch (ToInteger (SFID))
                        {
                            Case (One)
                            {
                                Store (GVER (Local0), Local1)
                            }

                        }
                    }
                    Case (0x02)
                    {
                        Switch (ToInteger (SFID))
                        {
                            Case (One)
                            {
                                Store (GTSI (Local0), Local1)
                            }
                            Case (0x02)
                            {
                                Store (GTMP (Local0), Local1)
                            }
                            Case (0x03)
                            {
                                Store (STMT (Local0), Local1)
                            }
                            Case (0x04)
                            {
                                Store (GPSI (Local0), Local1)
                            }
                            Case (0x05)
                            {
                                Store (GPCI (Local0), Local1)
                            }
                            Case (0x06)
                            {
                                Store (GLIV (Local0), Local1)
                            }
                            Case (0x07)
                            {
                                Store (SLIV (Local0), Local1)
                            }
                            Case (0x08)
                            {
                                Store (GFNS (Local0), Local1)
                            }
                            Case (0x09)
                            {
                                Store (GCVA (Local0), Local1)
                            }

                        }
                    }
                    Case (0x03)
                    {
                        Switch (ToInteger (SFID))
                        {
                            Case (0x0C)
                            {
                                Store (GCPL (Local0), Local1)
                            }
                            Case (0x0D)
                            {
                                Store (SPLV (Local0), Local1)
                            }
                            Case (0x0E)
                            {
                                Store (GODP (Local0), Local1)
                            }
                            Case (0x0F)
                            {
                                Store (SODP (Local0), Local1)
                            }
                            Case (0x10)
                            {
                                Store (SBTT (Local0), Local1)
                            }
                            Case (0x11)
                            {
                                Store (GBTT (Local0), Local1)
                            }
                            Case (0x12)
                            {
                                Store (BACF (Local0), Local1)
                            }
                            Case (0x13)
                            {
                                Store (BACG (Local0), Local1)
                            }
                            Case (0x14)
                            {
                                Store (ACOL (Local0), Local1)
                            }
                            Case (0x15)
                            {
                                Store (CGMD (Local0), Local1)
                            }
                            Case (0x16)
                            {
                                Store (CGMG (Local0), Local1)
                            }

                        }
                    }
                    Case (0x04)
                    {
                        Switch (ToInteger (SFID))
                        {
                            Case (0x04)
                            {
                                Store (PAFS (Local0), Local1)
                            }
                            Case (0x05)
                            {
                                Store (PAFF (Local0), Local1)
                            }
                            Case (0x06)
                            {
                                Store (GFRS (Local0), Local1)
                            }
                            Case (0x07)
                            {
                                Store (SFRS (Local0), Local1)
                            }
                            Case (0x08)
                            {
                                Store (SPDT (Local0), Local1)
                            }
                            Case (0x09)
                            {
                                Store (RPDT (Local0), Local1)
                            }
                            Case (0x0A)
                            {
                                Store (RPPT (Local0), Local1)
                            }
                            Case (0x0B)
                            {
                                Store (SMLS (Local0), Local1)
                            }
                            Case (0x10)
                            {
                                Store (GWKM (Local0), Local1)
                            }
                            Case (0x11)
                            {
                                Store (SWKM (Local0), Local1)
                            }

                        }
                    }
                    Case (0x05)
                    {
                        Switch (ToInteger (SFID))
                        {
                            Case (One)
                            {
                                Store (GSUS (Local0), Local1)
                            }

                        }
                    }
                    Case (0x06)
                    {
                        Switch (ToInteger (SFID))
                        {
                            Case (0x04)
                            {
                                Store (GLOG (Local0), Local1)
                            }
                            Case (0x07)
                            {
                                Store (GNTB (Local0), Local1)
                            }
                            Case (0x08)
                            {
                                Store (SNTB (Local0), Local1)
                            }
                            Case (0x0A)
                            {
                                Store (GSWL (Local0), Local1)
                            }
                            Case (0x0C)
                            {
                                Store (GECL (Local0), Local1)
                            }
                            Case (0x11)
                            {
                                Store (SKBT (Local0), Local1)
                            }
                            Case (0x12)
                            {
                                Store (GKBT (Local0), Local1)
                            }
                            Case (0x0D)
                            {
                                Store (SPDV (Local0), Local1)
                            }
                            Case (0x0E)
                            {
                                Store (GPDV (Local0), Local1)
                            }
                            Case (0x0F)
                            {
                                Store (SOSF (Local0), Local1)
                            }
                            Case (0x10)
                            {
                                Store (GOSF (Local0), Local1)
                            }

                        }
                    }

                }

                Store (Local1, Index (WMRP, One))
                Release (MUTW)
                Return (WMRP)
            }

            Method (_WED, 1, NotSerialized)  // _Wxx: Wake Event
            {
                Return (\_SB.PCI0.LPCB.HWEC.WMEN)
            }
        }
    }
}

